/*
  Advanced examples of loops
  Created by Miguel Angel Rubio - marubio@ugr.es
  date: June 2014
  See instructions.txt file
  This example code is in the public domain.
 */

#include <PhysicalComputingDemonstrations.h>
#include <Servo.h>

void setup() {                
  
// The name of the servomotor
int pin_servo = 7;
Servo mi_servo;
mi_servo.attach(pin_servo);

// The names of the LEDs
int pin_rojo = 12;
int pin_naranja = 13;

//// Turn on the LEDs
//enciende_led(pin_rojo);
//enciende_led(pin_naranja);

  
//// Repeat the rotation three times
//for (int cont = 1; cont <= 3; cont++){
//    // Rotate in one direction
//    for (int angulo=0; angulo <= 180; angulo = angulo +5){
//        mover_servo(mi_servo,angulo);
//        para(.1);
//    }
//    
//    // Rotate in the other direction
//    for (int angulo=180; angulo <= 0; angulo = angulo - 5){
//        mover_servo(mi_servo,angulo);
//        para(.1);
//    }
//}


//// Complete version with flashes

//// Turn on the LEDs
//enciende_led(pin_rojo);
//enciende_led(pin_naranja);


//// Repeat the rotations three times
//for (int cont = 1; cont <= 3; cont++){
//  
//    // Change the flash
//    enciende_led(pin_rojo);
//    apaga_led(pin_naranja);
//    
//    
//    // Rotate in one direction
//    for (int angulo=0; angulo <= 180; angulo = angulo +5){
//        mover_servo(mi_servo,angulo);
//        
//        if (angulo > 90){
//          // Change the flash
//          apaga_led(pin_rojo);
//          enciende_led(pin_naranja);
//        }
//        para(.1);
//    }
//    
//    // Rotate in the other direction
//    for (int angulo=180; angulo <= 0; angulo = angulo - 5){
//        mover_servo(mi_servo,angulo);
//        if (angulo > 90){
//          // Change the flash
//          apaga_led(pin_rojo);
//          enciende_led(pin_naranja);
//        }
//        para(.1);
//    }
//}


Serial.begin(9600);


// See the distance value
float distancia = lee_distancia();

// Keep watching...
while (distancia > 30){
    Serial.println(distancia);
	// See the distance value
    distancia = lee_distancia();
    para(.5);
}


// Turn on the LEDs
enciende_led(pin_rojo);
enciende_led(pin_naranja);

// Repeat the rotations three times
for (int cont = 1; cont <= 3; cont++){
    // Rotate in one direction
    for (int angulo=0; angulo <= 180; angulo = angulo +5){
        mover_servo(mi_servo,angulo);
        para(.1);
    }
    
    // Rotate in the other direction
    for (int angulo=180; angulo <= 0; angulo = angulo - 5){
        mover_servo(mi_servo,angulo);
        para(.1);
    }
}

apaga_led(pin_rojo);
apaga_led(pin_naranja);
mover_servo(mi_servo,90);
}



void loop() {
}


// Function lee_distancia. Reads the distance using Arduino
// The sensor is the LV-MaxSonar EZ1 
float lee_distancia(){

 // The pin we are going to use to read the distance value
 int analog_pin = 3;
 // Number of measures
 int num_medidas = 15;

 // We take num_medidas measures to stabilize the result
 // The sensor values are not very stable
 float distancia_inst = 0;
 float voltaje;

 
 for (int cont = 0; cont < num_medidas; cont++){
    voltaje = lee_voltaje(analog_pin); // Direct measure
    voltaje = voltaje/2; // In units, normalized
    distancia_inst = distancia_inst + voltaje*2.54; // In cm
 }

 // We take the mean and return it
 float distancia = distancia_inst/num_medidas;
 return distancia;
} 

