/*
  Example of uso of inputs and outputs
  Created by Miguel Angel Rubio - marubio@ugr.es
  date: June 2014
  See instructions.txt file
  This example code is in the public domain.
 */

#include <PhysicalComputingDemonstrations.h>

void setup() {                

Serial.begin(9600);

escribe(16);

}



void loop() {
  int temper = lee_temp_salida();
  Serial.println(temper);
  para(1);
}


// Function lee_temp_salida. Reads temperature using Arduino
// The sensor is the TMP36 of the Arduino Starter Kit
// Output: the temperature
int lee_temp_salida(){
 
 char str[256];
 // The pin we are going to use to reed the temperature
 int analog_pin = 0;

 // We run 20 measures to minimize the error
 float temp = 0;
 int num_medidas = 20;
 float voltaje;
 
 for (int cont = 0; cont < 20; cont++) {
    voltaje = lee_voltaje(analog_pin); // Direct measure
    voltaje = voltaje*5/1024; // Normalized voltage
    temp= temp+voltaje/0.01 - 50; // In ºC
 }

 // Do the mean and return it
 int temperatura = temp/num_medidas;
 return temperatura;
 
}


// Function lee_temp_salida. Reads temperature using Arduino
// The sensor is the TMP36 of the Arduino Starter Kit
// See the pdfs attached
void lee_temp(){
 
 char str[256];
 // The pin we are going to use to reed the temperature
 int analog_pin = 0;

 // We run 20 measures to minimize the error
 float temp = 0;
 int num_medidas = 20;
 float voltaje;
 
 for (int cont = 0; cont < 20; cont++) {
    voltaje = lee_voltaje(analog_pin); // Direct measure
    voltaje = voltaje*5/1024; // Normalized voltage
    temp= temp+voltaje/0.01 - 50; // In ºC
 }

 // Do the mean and show it
 int temperatura = temp/num_medidas;
 sprintf(str, "La temperatura es    %d C",temperatura);
 Serial.println(str);
 
}


// LED output of the input binary number
// Maximun number 31
// We use all pins form 9 to 13
// Pin 13 is the least significant
// Pin 9 is the most significant
// To do the guessing game we need to use LEDs
// with different colours.
// Input num: the number we are going to transform into binary
void escribe (int num) {

// The LEDs which we are going to work with
int rango_led [5]= {9,10,11,12,13};
int val;

for (int cont = 0; cont < 5; cont++){
    val = num%2; // Calculate the remainder of the division by 2
    num = num/2; // Calculate the quotient and assign it to num
    
    // If binary value is 1
    if (val == 1)
        enciende_led(rango_led[cont]); // turn on LED
    // If not
    else 
        apaga_led(rango_led[cont]); // turn off LED
}
}
